%\documentclass[10pt]{beamer}
\documentclass[]{beamer}
\usetheme[
%%% option passed to the outer theme
%    progressstyle=fixedCircCnt,   % fixedCircCnt, movingCircCnt (moving is deault)
  ]{Feather}

% If you want to change the colors of the various elements in the theme, edit and uncomment the following lines

% Change the bar colors:
%\setbeamercolor{Feather}{fg=red!20,bg=red}

% Change the color of the structural elements:
%\setbeamercolor{structure}{fg=red}

% Change the frame title text color:
%\setbeamercolor{frametitle}{fg=blue}

% Change the normal text color background:
%\setbeamercolor{normal text}{fg=black,bg=gray!10}

%-------------------------------------------------------
% INCLUDE PACKAGES
%-------------------------------------------------------

\usepackage[utf8]{inputenc}
\usepackage[english]{babel}
\usepackage[T1]{fontenc}
\usepackage{helvet}
\usepackage{multirow}
\usepackage{xcolor}
\usepackage[export]{adjustbox}
\definecolor{purple}{HTML}{A91A91}
\definecolor{grey}{HTML}{333333}

%-------------------------------------------------------
% DEFFINING AND REDEFINING COMMANDS
%-------------------------------------------------------

% colored hyperlinks
\newcommand{\chref}[2]{
  \href{#1}{{\usebeamercolor[bg]{Feather}#2}}
}

%-------------------------------------------------------
% INFORMATION IN THE TITLE PAGE
%-------------------------------------------------------

\title[] % [] is optional - is placed on the bottom of the sidebar on every slide
{ % is placed on the title page
      \textbf{The emPeerTube strikes back}
}

\subtitle[Let's decentralize YouTube]
{
        \textbf{Let's decentralize YouTube}
%      \textbf{v. 1.0.0}
}

\author[Chocobozzz \& Framasky]
{      Chocobozzz \& Framasky
}

\institute[]
{
      Framasoft

  %there must be an empty line above this line - otherwise some unwanted space is added between the university and the country (I do not know why;( )
}

\date{4 February 2018}

\titlegraphic{\includegraphics[width=2cm,keepaspectratio]{img/fosdem}}

%-------------------------------------------------------
% THE BODY OF THE PRESENTATION
%-------------------------------------------------------

\begin{document}

%-------------------------------------------------------
% THE TITLEPAGE
%-------------------------------------------------------

{\1% % this is the name of the PDF file for the background
\begin{frame}[plain,noframenumbering] % the plain option removes the header from the title page, noframenumbering removes the numbering of this frame only
  \titlepage % call the title page information from above
\end{frame}}


%%\begin{frame}{Table of contents}{}
%%\tableofcontents
%%\end{frame}

%-------------------------------------------------------
\section{Introduction}
%-------------------------------------------------------
\subsection{YouTube has a de-facto monopoly}
\begin{frame}{Introduction}{YouTube has a de-facto monopoly}
    {\Large YouTube is hegemonic}

    It's not part of the decentralized web we love and want.

    \onslide<2-> And it comes with other problems: users spying, ads…

    \onslide<3-> The more it has videos, the more it attracts viewers, and the more it attracts videos makers… vicious circle.
\end{frame}
\subsection{We don't have real alternatives to YouTube}
\begin{frame}{Introduction}{We don't have real alternatives to YouTube}
    {\Large Hosting an alternative to YouTube hits two issues:}
    \begin{itemize}
        \item<2-> storage
        \item<3-> bandwidth
    \end{itemize}
    \onslide<4->{It would cost heaps of money}
\end{frame}

\begin{frame}{Introduction}{We don't have real alternatives to YouTube}
    {\Large Yes, we already have many self-hosting video software}

    \onslide<2->{But if it solves the storage problem (you only host your videos), there are other problems:}
    \begin{itemize}
        \item<3-> if a video goes viral, the bandwidth problem appears
        \item<4-> you have very little chance to be discovered through serendipity
    \end{itemize}
\end{frame}

\begin{frame}{Introduction}{A new hope}
    \only<1>{\center\includegraphics[width=\textwidth,keepaspectratio]{img/peertubance}}
    \onslide<2->{Let me introduce PeerTube}
    \begin{itemize}
        \item<3-> self-hosted video platform
        \item<4-> servers are federated through ActivityPub
        \item<5-> comments and likes are federated through ActivityPub too!
        \item<6-> use WebTorrent to stream videos
    \end{itemize}
\end{frame}

%-------------------------------------------------------
\section{History}
%-------------------------------------------------------

\subsection{A long time ago, in a country far far away}
\begin{frame}{History}{A long time ago, in a country far far away}
    {\Large A young developer, Chocobozzz, began to code an alternative to Youtube, based on Webtorrent: PeerTube.}
    \center\includegraphics[height=0.5\textheight,keepaspectratio]{img/screenshot1}
\end{frame}

\begin{frame}{History}{A long time ago, in a country far far away}
    {\Large The journey began in October 2015, on his free time}

    In October 2017, Framasoft non-profit organization hired him for four months to work full-time on PeerTube.
\end{frame}

\subsection{The Force is strong with him.}
\begin{frame}{History}{The Force is strong with him.}
    From the beginning, Chocobozzz wanted two things:

    \begin{itemize}
        \item<2-> server federation
        \item<3-> bandwidth share between the viewers of a video
    \end{itemize}
\end{frame}

%-------------------------------------------------------
\section{Technical background}
%-------------------------------------------------------

\subsection{Don't underestimate the Force.}
\begin{frame}{Technical background}{Don't underestimate the Force.}
    The technical background suffered a lot of changes through time.

    \begin{itemize}
        \item<2-> from JQuery to Angular 5, transpiled from TypeScript for the frontend
        \item<3-> from plain NodeJS JavaScript to TypeScript for the backend
        \item<4-> from MongoDB for the database to PostgreSQL
        \item<5-> from Electron to WebSeed
    \end{itemize}
\end{frame}

\begin{frame}{Technical background}{Don't underestimate the Force.}
    And finally, the federation protocol, which was developped for PeerTube only, has been replaced by ActivityPub.
\end{frame}

\subsection{The federation}
\begin{frame}{Technical background}{The federation}
    How does the federation work?

    \onslide<2-> For the server federation:
    \begin{itemize}
        \item<3-> server (A) can follow another server (B)…
        \item<4-> then it indexes the videos of server B and displays them on its home page.
        \item<5-> the videos of server B can be watched from server A interface…
        \item<6-> but are streamed from server B
    \end{itemize}
\end{frame}

\begin{frame}{Technical background}{The federation}
    For the comments/like/dislike federation:
    \begin{itemize}
        \item<1-> a user on server A can comment/like/dislike a video from another server B…
        \item<2-> his/her actions are pushed over federated servers, thanks to ActivityPub
        \item<3-> it works with other ActivityPub-aware softwares like Mastodon (may require some developments)

            \onslide<4-> Have a look on \url{https://frama.link/peertube-mastodon} if you don't believe me!
            \onslide<5-> (I find your lack of faith disturbing.)
    \end{itemize}
\end{frame}

\subsection{Bandwidth sharing}
\begin{frame}{Technical background}{Bandwidth sharing}
    Each time you're viewing a video from PeerTube, you're seeding it.

    \begin{itemize}
        \item<2-> if a video goes viral, the server doesn't have to support all the work
        \item<3-> you may find seeders more close to you (in terms of networks), reducing the trafic on GIX
    \end{itemize}
\end{frame}

%-------------------------------------------------------
\section{Current status and future}
%-------------------------------------------------------
\subsection{The Death Star will be completed on schedule.}
\begin{frame}{Current status and future}{The Death Star will be completed on schedule.}
    PeerTube is currently in alpha stage…

    \onslide<2-> but should be in beta by the end of March.
\end{frame}

\begin{frame}{Current status and future}{The Death Star will be completed on schedule.}
    The list is long, of already implemented features.

    \onslide<2-> Here are some:
    \begin{itemize}
        \item<3-> federated videos with their tags, categories, likes…
        \item<4-> federated videos abuses
        \item<5-> users can register, remove their account, be limited with a disk quota…
        \item<6-> roles (admin, moderator, user)
        \item<7-> explicit content system (aka NSFW)
        \item<8-> and more…
    \end{itemize}
\end{frame}

\subsection{Future developments}
\begin{frame}{Current status and future}{Future developments}
    The wishlist is long too…

    \begin{itemize}
        \item<2-> subtitles
        \item<3-> recommandation algorithm
        \item<4-> upload a video from an URL or a torrent file
        \item<5-> videos mirroring
        \item<6-> RSS feed
        \item<7-> and more…
    \end{itemize}
\end{frame}

\subsection{Future developments}
\begin{frame}{Current status and future}{Future developments}
    \only<1>{\center\includegraphics[width=\textwidth,keepaspectratio]{img/destroy}}
    \onslide<2-> \center (well, at least, have an alternative to YouTube)
\end{frame}

%-------------------------------------------------------
\section{Conclusion}
%-------------------------------------------------------
\begin{frame}{Conclusion}{Come to the dark side}
    \only<1-3>{There's still a lot of work…

    \onslide<2-3> Will you help?

    \onslide<3-3> \url{https://github.com/Chocobozzz/PeerTube/}}
    \only<4>{\center\includegraphics[max width=\textwidth, keepaspectratio]{img/come}}
    \only<5>{Download those slides on \url{https://frama.link/peertube-fosdem-2018}}
\end{frame}


{\3
\begin{frame}[plain,noframenumbering]
    \finalpage{
    }
\end{frame}}

\end{document}
